/*
utils.h
Copyright 2007-2021 Matt Heinzen

This file is part of Color Machine.

Color Machine is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

Color Machine is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
Color Machine; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __UTILS_H__
#define __UTILS_H__

#include "SDL.h"

enum Shape { SHAPE_CIRCLE, SHAPE_SQUARE, SHAPE_DIAMOND, SHAPE_HEXAGON, SHAPE_OCTAGON, SHAPE_MAX };

int randomRange(const int range);
int randomInt(const int low, const int high);
float randomFloat(const float low, const float high);
bool randomBool();
int randomSign();
Shape randomShape();
Uint8 randomColor();
void cycleColor(Uint8 &colorIndex, int const amount = 1);
Uint8 int2Color(int a);
void plotPixel(int const x, int const y, Uint8 const colorIndex);
void drawHLine(int x1, int x2, int y, Uint8 const colorIndex);
void drawVLine(int x, int y1, int y2, Uint8 const colorIndex);
void drawLine(int x1, int y1, int x2, int y2, Uint8 const colorIndex);
void drawBox(int x1, int y1, int x2, int y2, Uint8 const colorIndex);
void drawDisc(int x, int y, int r, Uint8 colorIndex);
void drawDiamond(int x, int y, int r, Uint8 colorIndex);
void drawHexagon(int x, int y, int r, Uint8 colorIndex);
void drawOctagon(int x, int y, int r, Uint8 colorIndex);
void drawShape(Shape s, int x, int y, int r, Uint8 colorIndex);

#endif // __UTILS_H__
